#pragma once

#include <pthread.h>
#include <common/common.h>

enum lkt_event_type {
    lkt_event_null      = 0,            /* NULL         */
    lkt_event_play_pos  = (1 << 1),     /* size_t       */
    lkt_event_play_file = (1 << 2),     /* const char*  */
};

#define lkt_event_play (lkt_event_play_pos | lkt_event_play_file)

typedef struct {
    unsigned int type;
    void *attr;
} lkt_event;

struct queue {
    pthread_mutex_t lock;

    volatile lkt_event *contents;
    volatile size_t size;
    volatile size_t last;

    volatile int available;
};

int lkt_queue_new(struct queue *);
void lkt_queue_free(struct queue *);

void lkt_queue_send(struct queue *, enum lkt_event_type, void *attr);
lkt_event lkt_queue_handle(struct queue *);

void lkt_queue_make_available(struct queue *, enum lkt_event_type);
