#define _POSIX_C_SOURCE 200809L

#include <common/common.h>
#include <lektor/mkv.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

void
mdtcat(struct kara_metadata *mdt, char **ret)
{
    size_t size = strlen(mdt->song_name) + strlen(mdt->source_name) +
                  strlen(mdt->category) + strlen(mdt->language)     +
                  strlen(mdt->author_name) + strlen(mdt->song_type) +
                  /* Null byte */ 1 + /* Separators */ 12 + 5       +
                  long_length(mdt->song_number);
    *ret = malloc(sizeof(char) * size);
    if (!*ret) {
        LOG_ERROR("MKV", "%s", "Out of memory");
        return;
    }

    safe_snprintf(*ret, size, "%s - %s / %s - %s%d - %s [ %s ]", mdt->category,
                  mdt->language, mdt->source_name, mdt->song_type,
                  mdt->song_number, mdt->song_name, mdt->author_name);
}
